/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"xl.h"


BINARY_TABLE	div_tt[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{0,0,0,0,0,0,0,0,0},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,div_ii}, /* GBT_INTEGER */
		{conv_if,0,div_ff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,conv_if,div_ff}, /* GBT_INTEGER */
		{0,0,div_ff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};

BINARY_TABLE	rem_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{0,0,0,0,0,0,0,0,0},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,rem_ii}, /* GBT_INTEGER */
		{conv_if,0,rem_ff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,conv_if,rem_ff}, /* GBT_INTEGER */
		{0,0,rem_ff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	equ_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{
		{0,0,equ_pair}, /* GBT_NULL */
		{0,0,0},	/* GBT_ERROR */
		{0,0,equ_pair},	/* GBT_PAIR */
		{0,0,not_equal},/* GBT_SYMBOL */
		{0,0,not_equal},/* GBT_STRING */
		{0,0,not_equal},/* GBT_INTEGER */
		{0,0,not_equal},/* GBT_FLOAT */
		{0,0,not_equal},/* GBT_FUNC */
		{0,0,0},	/* GBT_DELAY */
	},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{
		{0,0,equ_pair}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,equ_pair}, /* GBT_PAIR */
		{0,0,not_equal}, /* GBT_SYMBOL */
		{0,0,not_equal}, /* GBT_STRING */
		{0,0,not_equal}, /* GBT_INTEGER */
		{0,0,not_equal}, /* GBT_FLOAT */
		{0,0,not_equal}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_SYMBOL */
	{
		{0,0,not_equal}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,not_equal}, /* GBT_PAIR */
		{0,0,equ_sym}, /* GBT_SYMBOL */
		{0,0,not_equal}, /* GBT_STRING */
		{0,0,not_equal}, /* GBT_INTEGER */
		{0,0,not_equal}, /* GBT_FLOAT */
		{0,0,not_equal}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_STRING */
	{
		{0,0,not_equal}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,not_equal}, /* GBT_PAIR */
		{0,0,not_equal}, /* GBT_SYMBOL */
		{0,0,equ_str}, /* GBT_STRING */
		{0,0,not_equal}, /* GBT_INTEGER */
		{0,0,not_equal}, /* GBT_FLOAT */
		{0,0,not_equal}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,not_equal}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,not_equal}, /* GBT_PAIR */
		{0,0,not_equal}, /* GBT_SYMBOL */
		{0,0,not_equal}, /* GBT_STRING */
		{0,0,equ_int}, /* GBT_INTEGER */
		{conv_if,0,equ_float}, /* GBT_FLOAT */
		{0,0,not_equal}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,not_equal}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,not_equal}, /* GBT_PAIR */
		{0,0,not_equal}, /* GBT_SYMBOL */
		{0,0,not_equal}, /* GBT_STRING */
		{0,conv_if,equ_float}, /* GBT_INTEGER */
		{0,0,equ_float}, /* GBT_FLOAT */
		{0,0,not_equal}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{
		{0,0,not_equal}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,not_equal}, /* GBT_PAIR */
		{0,0,not_equal}, /* GBT_SYMBOL */
		{0,0,not_equal}, /* GBT_STRING */
		{0,0,not_equal}, /* GBT_INTEGER */
		{0,0,not_equal}, /* GBT_FLOAT */
		{0,0,equ_func}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};

BINARY_TABLE	leq_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{
		{0,0,leq_null}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_diff}, /* GBT_PAIR */
		{0,0,leq_diff}, /* GBT_SYMBOL */
		{0,0,leq_diff}, /* GBT_STRING */
		{0,0,leq_diff}, /* GBT_INTEGER */
		{0,0,leq_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{
		{0,0,leq_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_pair}, /* GBT_PAIR */
		{0,0,leq_diff}, /* GBT_SYMBOL */
		{0,0,leq_diff}, /* GBT_STRING */
		{0,0,leq_diff}, /* GBT_INTEGER */
		{0,0,leq_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_SYMBOL */
	{
		{0,0,leq_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_diff}, /* GBT_PAIR */
		{0,0,leq_sym}, /* GBT_SYMBOL */
		{0,0,leq_diff}, /* GBT_STRING */
		{0,0,leq_diff}, /* GBT_INTEGER */
		{0,0,leq_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_STRING */
	{
		{0,0,leq_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_diff}, /* GBT_PAIR */
		{0,0,leq_diff}, /* GBT_SYMBOL */
		{0,0,leq_str}, /* GBT_STRING */
		{0,0,leq_diff}, /* GBT_INTEGER */
		{0,0,leq_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,leq_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_diff}, /* GBT_PAIR */
		{0,0,leq_diff}, /* GBT_SYMBOL */
		{0,0,leq_diff}, /* GBT_STRING */
		{0,0,leq_int}, /* GBT_INTEGER */
		{conv_if,0,leq_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,leq_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,leq_diff}, /* GBT_PAIR */
		{0,0,leq_diff}, /* GBT_SYMBOL */
		{0,0,leq_diff}, /* GBT_STRING */
		{0,conv_if,leq_float}, /* GBT_INTEGER */
		{0,0,leq_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};

BINARY_TABLE	lt_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{
		{0,0,lt_null}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_diff}, /* GBT_PAIR */
		{0,0,lt_diff}, /* GBT_SYMBOL */
		{0,0,lt_str}, /* GBT_STRING */
		{0,0,lt_diff}, /* GBT_INTEGER */
		{0,0,lt_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{
		{0,0,lt_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_pair}, /* GBT_PAIR */
		{0,0,lt_diff}, /* GBT_SYMBOL */
		{0,0,lt_diff}, /* GBT_STRING */
		{0,0,lt_diff}, /* GBT_INTEGER */
		{0,0,lt_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_SYMBOL */
	{
		{0,0,lt_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_diff}, /* GBT_PAIR */
		{0,0,lt_sym}, /* GBT_SYMBOL */
		{0,0,lt_diff}, /* GBT_STRING */
		{0,0,lt_diff}, /* GBT_INTEGER */
		{0,0,lt_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_STRING */
	{
		{0,0,lt_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_diff}, /* GBT_PAIR */
		{0,0,lt_diff}, /* GBT_SYMBOL */
		{0,0,lt_str}, /* GBT_STRING */
		{0,0,lt_diff}, /* GBT_INTEGER */
		{0,0,lt_diff}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,lt_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_diff}, /* GBT_PAIR */
		{0,0,lt_diff}, /* GBT_SYMBOL */
		{0,0,lt_diff}, /* GBT_STRING */
		{0,0,lt_int}, /* GBT_INTEGER */
		{conv_if,0,lt_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,lt_diff}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,lt_diff}, /* GBT_PAIR */
		{0,0,lt_diff}, /* GBT_SYMBOL */
		{0,0,lt_diff}, /* GBT_STRING */
		{0,conv_if,lt_float}, /* GBT_INTEGER */
		{0,0,lt_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	add_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,add_str}, /* GBT_STRING */
		{0,conv_is,add_str}, /* GBT_INTEGER */
		{0,conv_fs,add_str}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{conv_is,0,add_str}, /* GBT_STRING */
		{0,0,add_int}, /* GBT_INTEGER */
		{conv_if,0,add_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{conv_fs,0,add_str}, /* GBT_STRING */
		{0,conv_if,add_float}, /* GBT_INTEGER */
		{0,0,add_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	mul_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{0,0,0,0,0,0,0,0,0},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,mul_int}, /* GBT_INTEGER */
		{conv_if,0,mul_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,conv_if,mul_float}, /* GBT_INTEGER */
		{0,0,mul_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};

BINARY_TABLE	sub_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{0,0,0,0,0,0,0,0,0},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,sub_int}, /* GBT_INTEGER */
		{conv_if,0,sub_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,conv_if,sub_float}, /* GBT_INTEGER */
		{0,0,sub_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	and_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,and_int}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	or_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,or_int}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	xor_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,xor_int}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	And_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,And_int}, /* GBT_INTEGER */
		{0,0,And_int_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,And_float_int}, /* GBT_INTEGER */
		{0,0,And_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};



BINARY_TABLE	Or_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,Or_int}, /* GBT_INTEGER */
		{0,0,Or_int_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,Or_float_int}, /* GBT_INTEGER */
		{0,0,Or_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


BINARY_TABLE	Xor_t[GBT_MAX][GBT_MAX] = {
/* GBT_NULL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_ERROR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_PAIR */
	{0,0,0,0,0,0,0,0,0},
/* GBT_SYMBOL */
	{0,0,0,0,0,0,0,0,0},
/* GBT_STRING */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,0}, /* GBT_INTEGER */
		{0,0,0}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_INTEGER */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,Xor_int}, /* GBT_INTEGER */
		{0,0,Xor_int_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FLOAT */
	{
		{0,0,0}, /* GBT_NULL */
		{0,0,0}, /* GBT_ERROR */
		{0,0,0}, /* GBT_PAIR */
		{0,0,0}, /* GBT_SYMBOL */
		{0,0,0}, /* GBT_STRING */
		{0,0,Xor_float_int}, /* GBT_INTEGER */
		{0,0,Xor_float}, /* GBT_FLOAT */
		{0,0,0}, /* GBT_FUNC */
		{0,0,0} /* GBT_DELAY */
	},
/* GBT_FUNC */
	{0,0,0,0,0,0,0,0,0},
/* GBT_DELAY */
	{0,0,0,0,0,0,0,0,0}
};


